package com.myoa.engineering.crawl.shopping.configuration.slack;

import com.myoa.engineering.crawl.shopping.configuration.slack.properties.SlackSecretProperties;
import com.slack.api.Slack;
import com.slack.api.methods.MethodsClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class SlackConfiguration {

    private static final String DEFAULT_BOT_UNIT_NAME = "shopping-crawler";

    @Bean
    public MethodsClient slackMethodsClient(SlackSecretProperties slackSecretProperties) {
        String token = slackSecretProperties.find(DEFAULT_BOT_UNIT_NAME).getToken();
        return Slack.getInstance().methods(token);
    }

}
