package com.myoa.engineering.crawl.shopping.crawlhandler;

import com.myoa.engineering.crawl.shopping.infra.client.fmkorea.FmkoreaBoardClientV2;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;


@Service
public class FmkoreaCookieService {

    private final FmkoreaBoardClientV2 fmkoreaBoardClientV2;

    public FmkoreaCookieService(FmkoreaBoardClientV2 fmkoreaBoardClientV2) {
        this.fmkoreaBoardClientV2 = fmkoreaBoardClientV2;
    }

    @Cacheable(cacheNames = "crawltarget.fmkorea", key = "#root.methodName")
    public String getCookie() {
        String fakeHtml = fmkoreaBoardClientV2.getBoardHtml(1, null);
        return FmkoreaFake430Resolver.resolveFake430(fakeHtml);
    }
}
