package com.myoa.engineering.crawl.shopping.domain.model;

import com.myoa.engineering.crawl.shopping.domain.model.v2.ArticleModel;
import com.slack.api.methods.response.chat.ChatPostMessageResponse;
import lombok.*;

import java.util.List;
import java.util.stream.Collectors;


@ToString
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class UserNotifyModel {
    private String slackId;
    private List<ArticleModel> articles;
    private ChatPostMessageResponse chatPostMessageResponse;

    public String toCompositedMessage() {
        return wrapUserId() + "\n" +
                articles.stream()
                        .map(ArticleModel::convertArticletoMessage)
                        .collect(Collectors.joining("\n"));
    }

    private String wrapUserId() {
        return "<@" + slackId + ">";
    }


}
