package com.myoa.engineering.crawl.shopping.infra.client.fmkorea;

import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.client.WebClient;

@Slf4j
@Component
public class FmkoreaBoardClientV2 {

    private static final String URI_BOARD = "/index.php";

    private final WebClient webClient;

    public FmkoreaBoardClientV2() {
        webClient = WebClient.builder()
                             .codecs(configurer -> configurer.defaultCodecs()
                                                             .maxInMemorySize(2 * 1024 * 1024))
                             .baseUrl("https://www.fmkorea.com")
                             .defaultHeader(HttpHeaders.USER_AGENT, "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.3")
                             .defaultHeader("Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7\n")
                             .defaultHeader(HttpHeaders.REFERER, "https://www.fmkorea.com")
                             .defaultHeader(HttpHeaders.ACCEPT_ENCODING, "gzip, deflate, br")
                             .defaultHeader(HttpHeaders.ACCEPT_LANGUAGE, "ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7")
                             .defaultHeader(HttpHeaders.CACHE_CONTROL, "max-age=0")
                             .defaultHeader("Sec-Ch-Ua", "\"Whale\";v=\"3\", \"Not-A.Brand\";v=\"8\", \"Chromium\";v=\"122\"")
                             .defaultHeader("Sec-Ch-Ua-Mobile", "?0")
                             .defaultHeader("Sec-Ch-Ua-Platform", "\"macOS\"")
                             .defaultHeader("Sec-Fetch-Dest", "document")
                             .defaultHeader("Sec-Fetch-Mode", "navigate")
                             .defaultHeader("Sec-Fetch-Site", "same-origin")
                             .defaultHeader("Upgrade-Insecure-Requests", "1")
                             .build();
    }

    public String getBoardHtml(Integer page, String cookie) {
        return webClient.get()
                        .uri(builder -> builder.path(URI_BOARD)
                                               .queryParam("page", page)
                                               .queryParam("mid", "hotdeal")
                                               .build())
                        .header("Cookie", cookie)
                        .exchangeToMono(clientResponse -> clientResponse.bodyToMono(String.class))
                        .block();
    }
}
