package com.myoa.engineering.crawl.shopping.service;

import com.myoa.engineering.crawl.shopping.domain.entity.v2.AppUser;
import com.myoa.engineering.crawl.shopping.infra.repository.v2.AppUserRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class AppUserCommandService {
    private final AppUserRepository appUserRepository;

    public AppUserCommandService(AppUserRepository appUserRepository) {
        this.appUserRepository = appUserRepository;
    }

    @Transactional
    public void register(String slackId, String userName) {
        appUserRepository.findBySlackId(slackId)
                         .ifPresent(user -> {
                             throw new IllegalArgumentException("이미 등록된 사용자입니다.");
                         });

        AppUser appUser = AppUser.builder()
                                 .enabled(true)
                                 .slackId(slackId)
                                 .name(userName)
                                 .build();

        appUserRepository.save(appUser);
    }
}
