package com.myoa.engineering.crawl.shopping.service.slack;

import com.myoa.engineering.crawl.shopping.dto.slack.v2.SlackSlashCommandDTO;
import com.myoa.engineering.crawl.shopping.service.AppUserCommandService;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RegisterCommandHandler implements SlackCommandHandler {

    private final AppUserCommandService appUserCommandService;

    public RegisterCommandHandler(AppUserCommandService appUserCommandService) {
        this.appUserCommandService = appUserCommandService;
    }

    public List<String> handle(SlackSlashCommandDTO requestDTO) {
        if (!requestDTO.getCommand().equals("/등록")) {
            throw new IllegalArgumentException("Invalid command: " + requestDTO.getCommand());
        }

        final String userName = requestDTO.getText();

        try {
            appUserCommandService.register(requestDTO.getUser_id(), userName);
            return List.of("등록 완료");
        } catch (Exception e) {
            return List.of(e.getMessage());
        }

    }
}
