package com.myoa.engineering.crawl.shopping.service.slack.shopping;

import com.myoa.engineering.crawl.shopping.dto.slack.v2.SlackSlashCommandDTO;
import com.myoa.engineering.crawl.shopping.service.slack.ShoppingCommandProcessor;
import com.myoa.engineering.crawl.shopping.support.dto.constant.CrawlTarget;
import org.springframework.stereotype.Component;

import java.util.stream.Collectors;
import java.util.stream.Stream;

@Component
public class ListShoppingCommandProcessor implements ShoppingCommandProcessor {

    @Override
    public boolean isAssignable(String menuContext) {
        return menuContext.equals("목록");
    }

    @Override
    public String process(SlackSlashCommandDTO requestDTO) {
        return Stream.of(CrawlTarget.values())
                     .map(e -> e.getAlias() + " | " + e.isAvailable())
                     .collect(Collectors.joining("\n"));
    }
}
