package com.myoa.engineering.crawl.shopping.controller;

import com.slack.api.methods.MethodsClient;
import com.slack.api.methods.SlackApiException;
import com.slack.api.methods.request.chat.ChatPostMessageRequest;
import com.slack.api.model.block.DividerBlock;
import com.slack.api.model.block.HeaderBlock;
import com.slack.api.model.block.LayoutBlock;
import com.slack.api.model.block.SectionBlock;
import com.slack.api.model.block.composition.PlainTextObject;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@ActiveProfiles("local")
@ExtendWith(SpringExtension.class)
@SpringBootTest
class TestAPIControllerTest {

    @Autowired
    MethodsClient methodsClient;

    @Test
    void test1() throws SlackApiException, IOException {
        List<LayoutBlock> blocks = new ArrayList<>();
        HeaderBlock asdf = HeaderBlock.builder()
                                      .text(PlainTextObject.builder()
                                                           .text("asdf")
                                                           .build())
                                      .build();

        DividerBlock dividerBlock = DividerBlock.builder().build();
        SectionBlock section = SectionBlock.builder()
                                           .text(PlainTextObject.builder()
                                                                .text("• asdf")
                                                                .build())
                                           .build();
        blocks.add(asdf);
        blocks.add(section);
        blocks.add(section);
        blocks.add(section);
        blocks.add(dividerBlock);

        ChatPostMessageRequest request = ChatPostMessageRequest.builder()
                                                               .channel("notify_shopping")
                                                               .blocks(blocks)
                                                               .build();
        methodsClient.chatPostMessage(request);

    }

    private void notifyMessage() {

    }

}