package com.myoa.engineering.crawl.shopping.support.dto.constant;

import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public enum CrawlTarget {
    PPOMPPU_DOMESTIC("뽐뿌국내", true),
    PPOMPPU_OVERSEA("뽐뿌해외", true),
    FMKOREA("펨코", false),
    ;

    private final String alias;
    private final boolean available;

    public static CrawlTarget fromAlias(String alias) {
        for (CrawlTarget crawlTarget : values()) {
            if (crawlTarget.getAlias().equals(alias)) {
                return crawlTarget;
            }
        }
        throw new IllegalArgumentException("Not found alias: " + alias);
    }
}
