package com.myoa.engineering.crawl.shopping.controller;

import com.myoa.engineering.crawl.shopping.crawlhandler.CrawlHandler;
import com.myoa.engineering.crawl.shopping.infra.client.fmkorea.FmkoreaBoardClientV2;
import com.myoa.engineering.crawl.shopping.support.dto.constant.CrawlTarget;
import com.slack.api.methods.MethodsClient;
import com.slack.api.methods.SlackApiException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@RestController
@RequestMapping("/api/v1/exploit")
public class TestAPIController {

    private final MethodsClient methodsClient;
    private final List<CrawlHandler> crawlHandlers;
    private final FmkoreaBoardClientV2 fmkoreaBoardClientV2;

    public TestAPIController(MethodsClient methodsClient,
                             List<CrawlHandler> crawlHandlers,
                             FmkoreaBoardClientV2 fmkoreaBoardClientV2) {
        this.methodsClient = methodsClient;
        this.crawlHandlers = crawlHandlers;
        this.fmkoreaBoardClientV2 = fmkoreaBoardClientV2;
    }

    @GetMapping("/triggers")
    public void triggerExploit(@RequestParam("crawlTarget") CrawlTarget crawlTarget) {
        crawlHandlers
                .stream().filter(e -> e.getCrawlTarget().equals(crawlTarget))
                .forEach(CrawlHandler::handle);
    }

    @GetMapping("/ratelimiter")
    public void triggerExploit() {
        log.info("will be called page 1");
        fmkoreaBoardClientV2.getBoardHtml(1, null);
        log.info("called page 1");

    }

    private Map<String, String> generateRequestParams(int pageId) {
        Map<String, String> params = new HashMap<>();
        params.put("mid", "hotdeal");
        params.put("page", String.valueOf(pageId));
        return params;
    }

    @GetMapping("/test-message")
    public void testMessage() throws SlackApiException, IOException {
        methodsClient.chatPostMessage(req -> req
                .channel("notify_shopping")
                .text("Hello, World!"));
    }
}
